/* $Header: report.h,v 3.0 88/04/14 09:24:28 jos Exp $ */
/*
 *  This file is part of the Amsterdam SGML Parser.
 *
 *  Copyright: Faculteit Wiskunde en Informatica
 *             Department of Mathematics and Computer Science
 *             Vrije Universiteit Amsterdam
 *             The Netherlands
 *
 *  Authors:   Sylvia van Egmond
 *             Jos Warmer
 */

#define NO_LABEL	  0		/* unknown switch label */
#define AMB_LOOP	  1		/* loop in content model */
#define AMB_ALTER	  2		/* alternation conflict */
#define AMB_FOLLOWS	  3		/* first == follows */
#define AMB_CLASH	  4		/* clash in element */
#define ATTR_ID_TYPE	  5		/* default attr. ID wrong */
#define ATTR_ID_DEFAULT	  6		/* default val. with ID */
#define ATTR_NOT_UNIQUE	  7		/* attr. name not unique */
#define ATTR_TWO_ID	  8		/* two ID's in 1 attlist */
#define ATTR_TWO_TOKEN	  9		/* two tokens in 1 attlist */
#define ER_GRPGTCNT	 10		/* > GRPGTCNT */
#define WAR_GRPLVL	 11		/* > GRPLVL */
#define ER_CAPACITY	 12		/* error in capacity */
#define ELEM_UNDEF	 13		/* element undefined */
#define CAP_NAME	 14		/* wrong capacity name */
#define SGML_WRONG_VAL	 15		/* wrong value */
#define SHUN_TWO	 16		/* shun. ch. twice declared */
#define SHUN_NOT_ACC	 17		/* shun. ch. not defined */
#define SHUN_UNDEF	 18		/* also shun_ch in SGML */
#define DELIM_UNKNOWN	 19		/* unknown delim. */
#define DELIM_UNDEF	 20		/* delim also in SGML */
#define QUANT_NAME	 21		/* wrong quantity-name */
#define FILE_OPEN	 22		/* cannot open file */
#define LLGEN_EOF	 23		/* llgen expects EOF */
#define LLGEN_DEL	 24		/* llgen deletes a token */
#define LLGEN_INSERT	 25		/* llgen inserts a token */
#define INCL_UNDEF	 26		/* unknown incl. name */
#define EXCL_UNDEF	 27		/* unknown excl. name */
#define ELEM_UNREACH	 28		/* unreachable element */
#define WAR_LITLEN	 29		/* > LITLEN */
#define WAR_ATTCNT	 30		/* > ATTCNT */
#define KEY_WRONG	 31		/* wrong keyword */
#define WAR_GRPCNT	 32		/* > GRPCNT */
#define DIFF_CONN	 33		/* different connectors */
#define BASIC_SGML	 34		/* not basic SGML */
#define BASIC_CAP_REF	 35		/* not basic capacity set */
#define BASIC_SCOPE	 36		/* wrong scope */
#define BASIC_SYN_SCOPE	 37		/* not basic syntax ref. set */
#define BASIC_SWITCHES	 38		/* no switches allowed */
#define BASIC_SHUN_DEF	 39		/* shun. ch. predefined */
#define BASIC_SHUN_CTR	 40		/* shun. ch. are control ch. */
#define BASIC_FUNC	 41		/* wrong sgml function */
#define BASIC_TAB_FUNC	 42		/* only tab is extra func. */
#define BASIC_RULE	 43		/* naming rules go wrong */
#define BASIC_NAME_GEN	 44		/* namecase general=yes */
#define BASIC_NAME_ENT	 45		/* namecase entity=no */
#define BASIC_SHORT	 46		/* only prefined short ref. */
#define BASIC_NO	 47		/* no reserved names allowed */
#define BASIC_YES	 48		/* features always allowed */
#define BASIC_APPL_INFO	 49		/* appl. may not be spec. */
#define ATTR_DOUBLE	 50		/* 2 poss. names */
#define ATTR_NO_NAME	 51		/* no attr.name for value */
#define INCL_EXCL	 52		/* same time incl. and excl. */
#define NOT_OMIT_END	 53		/* omit end not allowed */
#define ATTR_UNKNOWN	 54		/* unknown attr. name */
#define WAR_ATTSPLEN	 55		/* > ATTSPLEN */
#define WAR_TAGLEN	 56		/* > TAGLEN */
#define ATTR_NON_NAME	 57		/* non namechar attr. */
#define WAR_NAMELEN	 58		/* > NAMELEN */
#define ATTR_NON_NUMBER	 59		/* non number attr. */
#define ATTR_NOT_KNOWN	 60		/* unknown value */
#define ATTR_NON_NTOK	 61		/* non nametoken attr. */
#define ATTR_NON_NRTOK	 62		/* non numbertoken attr. */
#define ATTR_NON_CDATA	 63		/* non cdata attr. */
#define ATTR_EMPTY_LIT	 64		/* empty literal attr. */
#define ENT_REDEF	 65		/* redefinition entity */
#define ENT_NOT_NDATA	 66		/* not NDATA implemented */
#define ENT_NOT_SUB	 67		/* not SUBDOC implemented */
#define ENT_UNDEF	 68		/* entity not defined */
#define SYSTEM_PUSH	 69		/* system error, pushback */
#define ENT_RECUR	 70		/* recursive entity */
#define SHORT_DOUBLE	 71		/* double short ref. map */
#define SHORT_UNDEF_ROLE 72		/* undef. shortref. role */
#define SHORT_ROLE_TWO	 73		/* double shortref. role */
#define SHORT_UNDEF	 74		/* undefined shortref map */
#define USE_ERROR	 75		/* usemap not in document */
#define SYSTEM_ALLOC	 76		/* allocation error */
#define WAR_PILEN	 77		/* > PILEN */
#define WAR_PAR_NAME	 78		/* par.ent.ref > NAMELEN - 1 */
#define ENT_PAR_SCDATA	 79		/* S/CDATA not in par. entity */
#define ENT_PAR_NDATA	 80		/* NDATA/SUB. not in par.ent. */
#define WAR_TAG_MARK	 81		/* > TAGLVL */
#define MS_NOT_OPEN	 82		/* marked sec. not open */
#define USE_DTD		 83		/* usemap without elements */
#define ATTR_REQ	 84		/* attr. required, not given */
#define ATTR_FIXED	 85		/* attr. fixed, def != given */
#define ATTR_CURRENT	 86		/* attr. current, not filled */
#define WAR_OPEN_ELEM	 87		/* open elem > TAGLVL */
#define ELEM_EXCL	 88		/* element excluded */
#define TAG_EMPTY	 89		/* empty tag outside elem */
#define TAG_UNKNOWN	 90		/* unknown tag */
#define TAG_NO_CLOSE	 91		/* endtag without close */
#define CHREF_UNKNOWN	 92		/* char.ref wrong */
#define CHREF_ERROR	 93		/* wrong ch in char.ref */
#define ATTR_RANGE	 94		/* token ocuurs 2 in range */
#define ENT_OPEN	 95		/* too much open entities */
#define ATTR_ID_UNIQUE	 96		/* id-value is not unique */
#define ATTR_ID_UNREF	 97		/* id-value, no corr. idref */
#define ATTR_IDREF_UNREF 98		/* idref-value, no corr. id */
#define ELEM_REDEF       99		/* element defined twice */
#define LLGEN_DEL_CHARS 100		/* llgen deletes a string */
#define EXID_OPEN       101		/* cannot open extern id */
#define SYSTEM_CONSTR   102		/* constraint not ok */
#define SYSTEM_PB       103		/* too much pushback */
#define ATTR_EMP_CONT   104		/* attr. has empty content */
#define NOT_UNDEF	105		/* notation name undefined */
#define NOT_DEF_TWICE	106		/* not. name defined twice */
#define USE_TWICE    	107		/* two usemaps with one element */
#define ATTR_NOT_ELEM 	108		/* no associated element */
#define WAR_IDREF_GRP   109		/* IDREFS > GRPCNT */
#define ATTR_CONREF_NOT 110		/* conref & notation in same starttag */
#define REP_INSERTED    111		/* inserted ch. in rep-file */
#define REP_ASSERT      112		/* assert error in rep_pars.c */
#define REP_ATTR        113		/* unknown attr. in rep-file */
#define REP_ELEM        114		/* unknown elem. in rep-file */
#define REP_DEL         115		/* token deleted in rep-file */
#define REP_DEL_CHARS   116		/* string deleted in rep-file */
#define REP_NAME_START  117		/* non-name_start_char in rep-file */
#define REP_WAR_NAMELEN 118		/* > NAMELEN */
#define REP_NO_LABEL   	119		/* unknown switch label in rep-file */
#define WAR_PI		120		/* PI in dtd */

extern void report      (PAR  int, int, P_Group, P_Set, ...   RAP);
extern void fatal_report();
