/* sgmldecl.h: SGML declaration parsing. */

enum quantity {
     QATTCNT,
     QATTSPLEN,
     QBSEQLEN,
     QDTAGLEN,
     QDTEMPLEN,
     QENTLVL,
     QGRPCNT,
     QGRPGTCNT,
     QGRPLVL,
     QLITLEN,
     QNAMELEN,
     QNORMSEP,
     QPILEN,
     QTAGLEN,
     QTAGLVL
};

#define NQUANTITY ((int)(QTAGLVL+1))

enum capacity {
     TOTALCAP,
     ENTCAP,
     ENTCHCAP,
     ELEMCAP,
     GRPCAP,
     EXGRPCAP,
     EXNMCAP,
     ATTCAP,
     ATTCHCAP,
     AVGRPCAP,
     NOTCAP,
     NOTCHCAP,
     IDCAP,
     IDREFCAP,
     MAPCAP,
     LKSETCAP,
     LKNMCAP
};

extern char *captab[];


struct sgmldecl {
     long capacity[NCAPACITY];
     long subdoc;
     UNCH formal;
     UNCH omittag;
     UNCH shorttag;
     UNCH shortref;
     UNCH namecase[2];		/* case translation of general/entity names */
     int quantity[NQUANTITY];
};

extern struct sgmldecl sd;
extern UNCH appinfo[];

#define OMITTAG (sd.omittag)
#define SUBDOC (sd.subdoc)
#define SHORTTAG (sd.shorttag)
#define FORMAL (sd.formal)

#define ATTCNT (sd.quantity[QATTCNT])
#define ATTSPLEN (sd.quantity[QATTSPLEN])
#define BSEQLEN (sd.quantity[QBSEQLEN])
#define ENTLVL (sd.quantity[QENTLVL])
#define GRPGTCNT (sd.quantity[QGRPGTCNT])
#define GRPCNT (sd.quantity[QGRPCNT])
#define GRPLVL (sd.quantity[QGRPLVL])
#define LITLEN (sd.quantity[QLITLEN])
#define NAMELEN (sd.quantity[QNAMELEN])
#define NORMSEP (sd.quantity[QNORMSEP])
#define PILEN (sd.quantity[QPILEN])
#define TAGLEN (sd.quantity[QTAGLEN])
#define TAGLVL (sd.quantity[QTAGLVL])

#define NAMECASE (sd.namecase[0])
#define ENTCASE (sd.namecase[1])

#define YES 1
#define NO 0
